//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsvolumepresent.c,r42 2006-02-18 04:23:47 ingo $

#include "fsyspriv.h"

// DETECT IF A VOLUME IS STILL PRESENT

int FSVolumePresent(FS_VOLUME *fs)
{
int f;

if(!SDCardInserted()) return FS_NOCARD;

SDSelect(0);
if(SDSelect(fs->Disk->Rca)) return FS_OK;		// RCA IS VALID--> CARD WAS NEVER REMOVED
// CARD WAS REMOVED, RESET CARD
SD_CARD newcard;
if(!SDCardInit(&newcard)) return FS_NOCARD;

// CARD MAY HAVE BEEN REMOVED AND REINSERTED
for(f=0;f<4;++f)
{
if(newcard.CID[f]!=fs->Disk->CID[f]) {
// IT'S A DIFFERENT CARD
return FS_CHANGED;
}
}

// SAME CARD WAS OUT AND BACK IN
fs->Disk->Rca=newcard.Rca;
if(SDSelect(fs->Disk->Rca)) return FS_OK;
return FS_ERROR;
}
