//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***




#include <hpgcc3.h>

int xr_getdigits(XREAL *num,char *buffer,int base)
{

if(base==10) return xr_getdigits10(num,buffer);

	int bits,bias;
	int mask;
	int digit;
	int f;
	char *org=buffer;


// CONVERT LEFT-JUSTIFIED DIGITS
mask=base-1;		// only for powers of 2
bits=xr_getnumbits(base);

bias=(64+num->Exp)%bits;
if(bias<0) bias+=bits;
if(bias) bias=bits-bias;
for(f=bits;f<=64+bias;f+=bits,++buffer)
{
digit=(num->Mant>>(64-f+bias))&mask;
*buffer=(digit>9)? digit+87:digit+48;
}

/*
if(f-bias!=64) {
	// LAST BIT NEEDS ROUNDING
	// TODO: ROUND LAST BIT
}
*/

return (int) (buffer-org);

}
