//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_memmove.c 394 2007-03-05 03:40:13Z ingo $

#include <hpgcc3.h>
#include <master_globals.h>


void sat3_memmove(SAT_OBJECT satdest,SAT_OBJECT satsrc,int nibbles)
{
    
    int src=satsrc;
    int offset=satdest-satsrc,add;
	if(offset>0) {
	// MOVEUP
    src+=nibbles-8;
	add=-8;
	}
	else add=8;		// MOVEDOWN

    while(nibbles>=8) {
        sat3_poke(src+offset,sat3_peek(src,8),8);
        src+=add;
        nibbles-=8;
    }
    if(nibbles) {
		if(add<0) src+=8-nibbles;
		sat3_poke(src+offset,sat3_peek(src,nibbles),nibbles);
	}
}
