//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***




// $Id: asctime.c 465 2007-10-02 23:43:21Z ingo $

// ROMLIB CHECKED
// < ibl ; 2006-04-06 >

#include <hpgcc3.h>

char *
_isotime_r(const struct tm *tt,int strict, char *s)
{
    
    struct tm tmb,*t;
    
    if (tt == NULL) {
        sys_tm_RTC(&tmb);
        t = &tmb;
    }
    else
        t = (struct tm *)tt;
    
    sprintf(s,"%4d-%02d-%02d%c%02d:%02d:%02d",
                t->tm_year + 1900,
                t->tm_mon + 1,
                t->tm_mday,
                strict ? 'T' : ' ',
                t->tm_hour,
                t->tm_min,
                t->tm_sec);
    
    return s;
}


char *
asctime_r(const struct tm *tt,char *buf)
{
    return _isotime_r(tt,0,buf);
}
