//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <sys.h>
#include <conio.h>

int
printf(const char *fmt, ...)
{

    va_list argp;
    int ret;
    char *out;
    
    if (! (out = (char*) malloc(4096)) )
        sys_error("fatal:can't malloc in printf",-1);
        
    va_start(argp, fmt);
    
    ret = vsprintf(out,fmt,argp);
    puts_nonl(out);
    free(out);
    
    va_end(argp);
    
    return ret;

}
